{ File    : $URL: file:///D:/SVN/svnDelphi/trunk/DBIOS/src/utils/ConOut.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2020-03-13 10:46:05 +0100 (Fr, 13 Mrz 2020) $
  Revision: $Rev: 539 $
}
unit ConOut;

interface

uses
  Windows;

const
  TextAttr_Black        = 0;
  TextAttr_Blue         = FOREGROUND_BLUE;
  TextAttr_Green        = FOREGROUND_GREEN;
  TextAttr_Red          = FOREGROUND_RED;
  TextAttr_Cyan         = TextAttr_Blue or TextAttr_Green;
  TextAttr_Magenta      = TextAttr_Blue or TextAttr_Red;
  TextAttr_Brown        = TextAttr_Green or TextAttr_Red;
  TextAttr_LightGray    = TextAttr_Blue or TextAttr_Green or TextAttr_Red;
  TextAttr_DarkGray     = TextAttr_Black or FOREGROUND_INTENSITY;
  TextAttr_LightBlue    = TextAttr_Blue or FOREGROUND_INTENSITY;
  TextAttr_LightGreen   = TextAttr_Green or FOREGROUND_INTENSITY;
  TextAttr_LightRed     = TextAttr_Red or FOREGROUND_INTENSITY;
  TextAttr_LightCyan    = TextAttr_Cyan or FOREGROUND_INTENSITY;
  TextAttr_LightMagenta = TextAttr_Magenta or FOREGROUND_INTENSITY;
  TextAttr_Yellow       = TextAttr_Brown or FOREGROUND_INTENSITY;
  TextAttr_White        = TextAttr_LightGray or FOREGROUND_INTENSITY;

procedure WriteColored(const TextAttr: Word; const Msg: AnsiString);
procedure WriteLnColored(const TextAttr: Word; const Msg: AnsiString);

implementation

function GetTextAttribute: Word;
var
  ConScrBufInfo: TConsoleScreenBufferInfo;
begin
  Result := TextAttr_Black;

  if GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), ConScrBufInfo)
    then
    Result := ConScrBufInfo.wAttributes
end;

function SetTextAttribute(Attribute: Word): Boolean;
begin
  Result := SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), Attribute);
end;

procedure WriteColored(const TextAttr: Word; const Msg: AnsiString);
var
  OldTextAttr: Word;
begin
  OldTextAttr := GetTextAttribute;

  if OldTextAttr <> TextAttr_Black then
    SetTextAttribute(TextAttr);

  Write(Msg);

  if OldTextAttr <> TextAttr_Black then
    SetTextAttribute(OldTextAttr)
end;

procedure WriteLnColored(const TextAttr: Word; const Msg: AnsiString);
begin
  WriteColored(TextAttr, Msg);
  WriteLn
end;

end.